# Добавка за NVDA за LAMBDA #

* Автори: Alberto Zanella и екипът на LAMBDA-NVDA.
* Изтегляне на [стабилна версия][1]
* Изтегляне на [тестова версия][2]

Този проект е модул за приложение за софтуера LAMBDA. Беше вдъхновен от работата на Peter Lecky в Comenius University. 
LAMBDA (Linear Access to Mathematic for Braille Device and Audio-synthesis (Линеен Достъп до Математика за Брайлови Устройства и Аудио-синтез)) е софтуер, който помага на незрящите да четат и пишат математика като използват брайлов дисплей и/или речев синтезатор.
LAMBDA е резултат от проект на ЕС. За повече информация относно LAMBDA, моля, посетете [https://www.lambdaproject.org/](https://www.lambdaproject.org/).  
Текущата версия на добавката има брайлови таблици за италиански и испански
език и към момента интерфейсът й е преведен на повечето от езиците, на които
NVDA е официално преведен, защото добавката се превежда от преводаческата
общност на NVDA. Ако сте не-италиански потребител на LAMBDA и бихте желали
да допринесете с приспособяването на брайловата таблица за вашия език, не се
колебайте да се обърнете към автора (вижте по-долу) или да се абонирате за
пощенския списък на проекта.

**Забележка:** Тази добавка е разработена от Alberto Zanella като доброволна дейност. Нито авторът, нито сътрудниците са ангажирани в продажбата и/или разработката на софтуера LAMBDA. Ако имате нужда от повече информация относно LAMBDA, или имате нужда от помощ относно това как да го използвате, обърнете се към вашия местен дистрибутор. Ако сте се натъкнали на трудности при използването или инсталирането на тази добавка, моля, обърнете се към автора й или използвайте връзката "Issues" от страницата на проекта в Github. 

### [Официално хранилище в GitHub](https://github.com/lambda-nvda/lambdaNvda/)

## Възможности на добавката:

### Поддръжка на реч:

* Диалоговите прозорци и менютата биват правилно докладвани;
* Естествена речева поддръжка за математически формули с помощта на
  математическата машина на LAMBDA, например – "обединен корен от 3 делено
  на обединен корен от 3 x плюс 24, затваряне на обединения корен, минус 3
  равно на 0";
* Поддръжка на четене по знаци, думи, редове и прочитане на всичко;
* Чете при избирането или разширяването на даден текстов блок (с използване
  на Control+B и Shift+Control+B);
* Чете при навигиране в текстовия редактор при използване на стандартните
  команди на Windows и специфични за LAMBDA команди;
* Поддържат се както разширения, така и съкратения речев режим (можете да го
  изберете от менюто "Инструменти" ("Tools") в LAMBDA);
* Специални диалогови прозорци, като например "Структурен режим",
  "Калкулатор" и "Прозорец на матрицата" сега биват докладвани коректно и
  NVDA чете коректно при местене на курсора и при въвеждане на текст;
* Ехото при въвеждане използва текстообработката на LAMBDA, тъй че символите
  и маркерите ще бъдат докладвани коректно.

### Поддръжка на брайл:

* Добавката инсталира (в директорията на профила на потребителя) и активира
  персонализирана брайлова таблица. Тази таблица може да бъде различна за
  различните езици. Персонализираните брайлови таблици са направени от тези
  в скриптовете на JAWS за LAMBDA (jbt файл). След това символите и
  маркерите биват представени чрез същите точкови шаблони;
* Добавката създава профил за NVDA за стандартна брайлова конфигурация. Така
  изходът е настроен на персонализираната брайлова таблица само когато
  приложението LAMBDA е на фокус;
* Диалоговите прозорци и менютата биват правилно докладвани на брайл;
* Съдържанието на редактора бива правилно представено на брайл и
  потребителят е в състояние да навигира, използвайки брайловите клавиши за
  превъртане или стрелките за преместване;
* Започвайки от версия 1.1.0 на добавката, има два начина, по които може да
  се представя текстът в редактора на LAMBDA: "Плосък режим"и "Не-плосък
  режим". Когато е включен "Плосък режим", NVDA ще използва екранния модел,
  за да извлече информация от редактора и да се определи позицията на
  курсора. Това е особено полезно, когато потребителят трябва да се движи по
  екрана, дори на места с празно пространство (интервали). Когато е изключен
  "Плосък режим", изобразяването на текста на брайловия дисплей е
  по-стабилно, тъй като NVDA използва ППИ на Windows , за да го
  извлича. Когато обаче курсорът попадне в празно пространство (интервали) в
  края на реда на текста, брайловият дисплей не следва реално курсора,
  докато потребителят не добави празно пространство (интервал).

"Плоският режим" е задействан по подразбиране. Можете да го включвате и
изключвате с натискане на NVDA+Shift+F.

Силно ви препоръчваме да изключите плоския режим, ако използвате
персонализиран DPI в Windows (опция за оразмеряване по избор), особено
когато екранът ви е настроен на повече от 96 DPI (по-голямо от 100%).

* Структурата на диалоговите прозорци е опростена, повтарящата се информация
  е премахната;
* Селекцията ще се маркира правилно с използване на точки 7 и 8 и
  маркировката ще се опреснява коректно при използването на стандартните
  команди на Windows (Shift+стрелките) или специфичните за LAMBDA команди
  (Control+B, Control+Shift+B).

## Преди да започнете да използвате тази добавка.

Тази добавка създава профил за NVDA, именуван "lambda", който е обвързан с
приложението "lambda.exe". Профилът автоматично настройва всички опции за
брайл: персонализираната брайлова таблица, обвързването на фокуса и
настройките за плоския режим.

Ако при вас има друг профил със същото име, добавката няма да го замени и ще
трябва ръчно да настроите вашия конфигурационен профил.

За да предотвратите тази ситуация, ако имате специфични настройки, които
искате да запазите, можете да използвате "Съветник за възстановяване на
профила за LAMBDA". Прекият път за стартиране на този инструмент е
NVDA+Alt+R (когато LAMBDA е на фокус).

Също лесен вариант е да изтриете старите версии на профила "lambda" след
инсталирането на добавката. За да направите това, отворете менюто на NVDA,
изберете елемента "Конфигурационни профили" и натиснете ENTER.

В диалоговия прозорец "Конфигурационни профили" ще можете да намерите и
изтриете профила "lambda". Профилът ще бъде пресъздаден следващия път,
когато приложението LAMBDA бъде стартирано.

Изтриването на профила "lambda" би трябвало да помогне също така, когато
добавката срещне проблем. Например ако брайловата таблица не е указана
правилно, вместо ръчно да конфигурирате профила, можете просто да го
изтриете. Добавката ще създаде нов такъв при следващото зареждане на
редактора LAMBDA.

Всеки път щом се стартира редакторът LAMBDA, добавката проверява дали
съществува профил с име "lambda". Ако няма такъв, тя автоматично генерира
такъв профил със следната структура:

```
filename : userData\profiles\lambda.ini :

[braille]
	readByParagraph = False
	tetherTo = focus
	translationTable = path-to-the-addon-brailleTable-dir\tableName

[lambda]
	brailleFlatMode = True

```

Къде:

* път-до-директорията-на-добавката-с-брайловатаТаблица : е пълният път до
  директорията на добавката + "\brailleTables"
* имеНаТаблицата: зависи от текущия език на NVDA. Към момента са налични
  само италианската и испанската брайлови таблици, съответно
  "lambda-ita.utb" и "lambda-esp.utb".

## Клавишни команди на добавката:

* **NVDA+Shift+F**: Включване или изключване на плоския режим за брайла;
* **NVDA+Alt+R**: Отваряне на "Съветник за възстановяване на профила за
  LAMBDA";
* **NVDA+D**: Дублиране на редовете (използвайте това вместо Control+D).

## Известни проблеми:

Поради наличен в LAMBDA проблем, добавката предоставя допълнителна логика,
която докладва празните интервали. Тази логика може да е неуспешна в
следните ситуации:

* Когато думи като "space", "spazio", "Espacio", "интервал"и прочее, биват
  вмъквани в текста, те може да бъдат съобщавани от NVDA като част от
  местния езиков превод на NVDA.
* Празните редове не биват докладвани от речевата машина на LAMBDA. Вместо
  това, потребителят ще чува превода на думата "интервал". Това може да е
  както празен ред, така и ред, съдържащ само думата "интервал".

## Полезни съвети

Това е набор от съвети, които ще ви помогнат да използвате добавката по
по-ефективен начин.

* Съобщаване знак по знак: Обикновено, когато работите с математика бихте
  искали NVDA да докладва нещата, които въвеждате знак по знак. За да
  направите това, има няколко прости стъпки: Уверете се, че фокусът е в
  прозореца на LAMBDA или някои от неговите варианти (например
  шест-точковото представяне). Натиснете NVDA+2 (от цифровия ред) или
  отидете в менюто на NVDA -> Настройки -> Настройки на клавиатурата и
  сложете отметка на опцията "Изговаряй въведените букви или знаци"; отидете
  в LAMBDA -> Опции (Options) -> Гласови параметри (Voice parameters) и се
  уверете, че опцията "Ехо" ("Echo") е ВКЛЮЧЕНА, в противен случай NVDA няма
  да получава никаква информация от речевата машина, докато въвеждате. И
  готово – NVDA ще изговаря въведените знаци, но не се притеснявайте – само
  в LAMBDA или нейните специални прозорци, оставяйки настройките на NVDA за
  другите приложения както са си били досега.

## Пощенски списък за добавката:

Ако желаете да докладвате бъгове, да давате предложения или да допринесете с
нещо, можете да се абонирате за пощенския списък на добавката (на
английски). Можете да се абонирате посредством следната страница:
<https://groups.io/g/lambda-nvda>.

## Списък с промените

По-долу е даден списък на промените между различните версии на добавката. До
номера на версията, в скоби, е състоянието на разработката. Текущата тестова
версия не е включена, тъй като тя може да съдържа промени преди
отбелязването й като стабилна или отхвърлена като кандидат-издание.

### Версия 1.3.0 (стабилна)

* Поддръжка на по-нови версии на NVDA (поддръжка на Python 3)
* Отстранен е проблем, който, при натискане на командата за дублиране на
  реда (NVDA+D) на празен ред, придизвиква поставянето на съдържанието на
  клипборда. Сега, при натискане на NVDA+D върху празен ред, се вмъква нов
  празен ред, както се очаква.

### Версия 1.2.2 (стабилна)

* Подобрена е съвместимостта с WX Python версия 4 (въведена с NVDA
  2018.3). Предупреждението, свързано с wx.NewId (), вече не се показва в
  протокола за отстраняване на грешки.
* Имплементиран е guiHelper с цел подобряване външния вид на диалоговите
  прозорци.
* Нови езици. Обновени преводи.

### Версия 1.2.1a (стабилна)

Това обновление е предназначено като издание с дългосрочна поддръжка. Това
означава, че поне до юни 2018 г. няма да бъде издавана друга по-стабилна
версия. Правим го, за да осигурим на учащите се максимална стабилност и да
сведем до минимум промените през академичната година.

* Нови езици. Обновени преводи.

### Версия 1.2.1 (стабилна)

* Добавена е съвместимост с начина, по който NVDA 2017.3 управлява
  брайла. Обратната съвместимост е запазена.
* Отстранени са множество проблеми, свързани с брайла.

### Версия 1.2.0 (тестова)

Тази версия не бе публикувана като стабилна, тъй като версия 1.2.1 включва
множество отстранени грешки.

* Нови и обновени преводи.

### Версия 1.1.8 (стабилна)

* Първа стабилна версия.

[[!tag dev stable]]

[1]: https://addons.nvda-project.org/files/get.php?file=lambda

[2]: https://addons.nvda-project.org/files/get.php?file=lambda-dev
